package org.jeecg.modules.fbsRdrecord32.controller;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsRdrecord32.entity.FbsRdrecords32;
import org.jeecg.modules.fbsRdrecord32.service.IFbsRdrecords32Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 销售出库单主表（表体）
 * @author： jeecg-boot
 * @date：   2020-10-22
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsRdrecord32/fbsRdrecords32")
@Slf4j
public class FbsRdrecords32Controller {
	@Autowired
	private IFbsRdrecords32Service fbsRdrecords32Service;

	 /**
	  * 月成品出货统计(仓库管理看板)
	  * @return
	  */

	@RequestMapping(value = "getMonthSend")
	public Result<Map<String,Object>> getMonthSend(){
		Result<Map<String,Object>> result = new Result<>();
		Map<String,Object> mapList = new HashMap<>();
		try {
			List<Map<String,Object>> map = fbsRdrecords32Service.getMonthSend();
			if(map.size() > 0){
				for (Map<String,Object> m:map){
					mapList.put(m.get("cInvCName").toString(),m.get("iQuantity"));
				}
			}

			result.setResult(mapList);
			result.success("成功");

		}catch (Exception e){
			e.getMessage();
			result.error500("操作失败："+e.getMessage());
		}

		return result;
	}













	/**
	  * 分页列表查询
	 * @param fbsRdrecords32
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsRdrecords32>> queryPageList(FbsRdrecords32 fbsRdrecords32,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsRdrecords32>> result = new Result<IPage<FbsRdrecords32>>();
		QueryWrapper<FbsRdrecords32> queryWrapper = QueryGenerator.initQueryWrapper(fbsRdrecords32, req.getParameterMap());
		Page<FbsRdrecords32> page = new Page<FbsRdrecords32>(pageNo, pageSize);
		IPage<FbsRdrecords32> pageList = fbsRdrecords32Service.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsRdrecords32
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsRdrecords32> add(@RequestBody FbsRdrecords32 fbsRdrecords32) {
		Result<FbsRdrecords32> result = new Result<FbsRdrecords32>();
		try {
			fbsRdrecords32Service.save(fbsRdrecords32);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsRdrecords32
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsRdrecords32> edit(@RequestBody FbsRdrecords32 fbsRdrecords32) {
		Result<FbsRdrecords32> result = new Result<FbsRdrecords32>();
		FbsRdrecords32 fbsRdrecords32Entity = fbsRdrecords32Service.getById(fbsRdrecords32.getId());
		if(fbsRdrecords32Entity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsRdrecords32Service.updateById(fbsRdrecords32);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsRdrecords32> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsRdrecords32> result = new Result<FbsRdrecords32>();
		FbsRdrecords32 fbsRdrecords32 = fbsRdrecords32Service.getById(id);
		if(fbsRdrecords32==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsRdrecords32Service.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsRdrecords32> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsRdrecords32> result = new Result<FbsRdrecords32>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsRdrecords32Service.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsRdrecords32> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsRdrecords32> result = new Result<FbsRdrecords32>();
		FbsRdrecords32 fbsRdrecords32 = fbsRdrecords32Service.getById(id);
		if(fbsRdrecords32==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsRdrecords32);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsRdrecords32> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsRdrecords32 fbsRdrecords32 = JSON.parseObject(deString, FbsRdrecords32.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsRdrecords32, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsRdrecords32> pageList = fbsRdrecords32Service.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "销售出库单主表（表体）列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsRdrecords32.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("销售出库单主表（表体）列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsRdrecords32> listFbsRdrecords32s = ExcelImportUtil.importExcel(file.getInputStream(), FbsRdrecords32.class, params);
              for (FbsRdrecords32 fbsRdrecords32Excel : listFbsRdrecords32s) {
                  fbsRdrecords32Service.save(fbsRdrecords32Excel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsRdrecords32s.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
